<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/SymbolLookup/Walker.hh.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/SymbolLookup/Walker.hh</title>
<link href="../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../Scopes/global.html" >Global Namespace</a></span>
<span class="normal"><a href="../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/SymbolLookup/Walker.hh</b><pre class="sxr"><a id="line1"></a><span class="lineno"> 1</span><span class="line"><span class="comment">//</span></span>
<a id="line2"></a><span class="lineno"> 2</span><span class="line"><span class="comment">// Copyright (C) 2004 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno"> 3</span><span class="line"><span class="comment">// All rights reserved.</span></span>
<a id="line4"></a><span class="lineno"> 4</span><span class="line"><span class="comment">// Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno"> 5</span><span class="line"><span class="comment">// see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno"> 6</span><span class="line"><span class="comment">//</span></span>
<a id="line7"></a><span class="lineno"> 7</span><span class="line">#ifndef Synopsis_SymbolLookup_Walker_hh_</span>
<a id="line8"></a><span class="lineno"> 8</span><span class="line">#define Synopsis_SymbolLookup_Walker_hh_</span>
<a id="line9"></a><span class="lineno"> 9</span>
<a id="line10"></a><span class="lineno">10</span><span class="line">#include &lt;Synopsis/PTree.hh&gt;</span>
<a id="line11"></a><span class="lineno">11</span><span class="line">#include &lt;Synopsis/SymbolLookup/Scope.hh&gt;</span>
<a id="line12"></a><span class="lineno">12</span><span class="line">#include &lt;stack&gt;</span>
<a id="line13"></a><span class="lineno">13</span>
<a id="line14"></a><span class="lineno">14</span><span class="line"><span class="keyword">namespace</span> <a href="../../../Scopes/Synopsis.html" title="namespace Synopsis">Synopsis</a></span>
<a id="line15"></a><span class="lineno">15</span><span class="line">{</span>
<a id="line16"></a><span class="lineno">16</span><span class="line"><span class="keyword">namespace</span> <a href="../../../Scopes/Synopsis/SymbolLookup.html" title="namespace Synopsis::SymbolLookup">SymbolLookup</a></span>
<a id="line17"></a><span class="lineno">17</span><span class="line">{</span>
<a id="line18"></a><span class="lineno">18</span>
<a id="line19"></a><span class="lineno">19</span><span class="line"><span class="comment">//. This Walker adjusts the symbol lookup table while the parse tree</span></span>
<a id="line20"></a><span class="lineno">20</span><span class="line"><span class="comment">//. is being traversed such that symbols in the parse tree can be</span></span>
<a id="line21"></a><span class="lineno">21</span><span class="line"><span class="comment">//. looked up correctly in the right context.</span></span>
<a id="line22"></a><span class="lineno">22</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/SymbolLookup/Walker.html" title="class Synopsis::SymbolLookup::Walker">Walker</a> : <span class="keyword">public</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html" title="class Synopsis::PTree::Visitor">PTree::Visitor</a></span>
<a id="line23"></a><span class="lineno">23</span><span class="line">{</span>
<a id="line24"></a><span class="lineno">24</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line25"></a><span class="lineno">25</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/Walker.html#Walker_lScope_S_r" title="member function Synopsis::SymbolLookup::Walker::Walker(Scope*)">Walker</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope</a> *);</span>
<a id="line26"></a><span class="lineno">26</span><span class="line">  virtual <a href="../../../Scopes/Synopsis/SymbolLookup/Walker.html#_tWalker_l_r" title="member function Synopsis::SymbolLookup::Walker::~Walker()">~Walker</a>();</span>
<a id="line27"></a><span class="lineno">27</span>
<a id="line28"></a><span class="lineno">28</span><span class="line">  <span class="keyword">using</span> PTree::Visitor::visit;</span>
<a id="line29"></a><span class="lineno">29</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolLookup::Walker::visit(PTree::List*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/List.html" title="class Synopsis::PTree::List">PTree::List</a> *);</span>
<a id="line30"></a><span class="lineno">30</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolLookup::Walker::visit(PTree::Block*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Block.html" title="class Synopsis::PTree::Block">PTree::Block</a> *);</span>
<a id="line31"></a><span class="lineno">31</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolLookup::Walker::visit(PTree::TemplateDecl*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/TemplateDecl.html" title="class Synopsis::PTree::TemplateDecl">PTree::TemplateDecl</a> *);</span>
<a id="line32"></a><span class="lineno">32</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolLookup::Walker::visit(PTree::NamespaceSpec*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/NamespaceSpec.html" title="class Synopsis::PTree::NamespaceSpec">PTree::NamespaceSpec</a> *);</span>
<a id="line33"></a><span class="lineno">33</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolLookup::Walker::visit(PTree::FunctionDefinition*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/FunctionDefinition.html" title="class Synopsis::PTree::FunctionDefinition">PTree::FunctionDefinition</a> *);</span>
<a id="line34"></a><span class="lineno">34</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolLookup::Walker::visit(PTree::ClassSpec*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/ClassSpec.html" title="class Synopsis::PTree::ClassSpec">PTree::ClassSpec</a> *);</span>
<a id="line35"></a><span class="lineno">35</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolLookup::Walker::visit(PTree::DotMemberExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/DotMemberExpr.html" title="class Synopsis::PTree::DotMemberExpr">PTree::DotMemberExpr</a> *);</span>
<a id="line36"></a><span class="lineno">36</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolLookup::Walker::visit(PTree::ArrowMemberExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/ArrowMemberExpr.html" title="class Synopsis::PTree::ArrowMemberExpr">PTree::ArrowMemberExpr</a> *);</span>
<a id="line37"></a><span class="lineno">37</span>
<a id="line38"></a><span class="lineno">38</span><span class="line">  <span class="comment">//. Traverse the body of a namespace definition.</span></span>
<a id="line39"></a><span class="lineno">39</span><span class="line">  <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolLookup::Walker::traverse_body(PTree::NamespaceSpec*)">traverse_body</a>(<a href="../../../Scopes/Synopsis/PTree/NamespaceSpec.html" title="class Synopsis::PTree::NamespaceSpec">PTree::NamespaceSpec</a> *);</span>
<a id="line40"></a><span class="lineno">40</span><span class="line">  <span class="comment">//. Traverse the body of the class definition.</span></span>
<a id="line41"></a><span class="lineno">41</span><span class="line">  <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolLookup::Walker::traverse_body(PTree::ClassSpec*)">traverse_body</a>(<a href="../../../Scopes/Synopsis/PTree/ClassSpec.html" title="class Synopsis::PTree::ClassSpec">PTree::ClassSpec</a> *);</span>
<a id="line42"></a><span class="lineno">42</span><span class="line">  <span class="comment">//. Traverse the template parameter list of a template declaration.</span></span>
<a id="line43"></a><span class="lineno">43</span><span class="line">  <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolLookup::Walker::traverse_parameters(PTree::TemplateDecl*)">traverse_parameters</a>(<a href="../../../Scopes/Synopsis/PTree/TemplateDecl.html" title="class Synopsis::PTree::TemplateDecl">PTree::TemplateDecl</a> *);</span>
<a id="line44"></a><span class="lineno">44</span><span class="line">  <span class="comment">//. Traverse the body of the function definition.</span></span>
<a id="line45"></a><span class="lineno">45</span><span class="line">  <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolLookup::Walker::traverse_body(PTree::FunctionDefinition*)">traverse_body</a>(<a href="../../../Scopes/Synopsis/PTree/FunctionDefinition.html" title="class Synopsis::PTree::FunctionDefinition">PTree::FunctionDefinition</a> *);</span>
<a id="line46"></a><span class="lineno">46</span>
<a id="line47"></a><span class="lineno">47</span><span class="line"><span class="keyword">protected</span>:</span>
<a id="line48"></a><span class="lineno">48</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope const</a> *<a href="../../../Scopes/Synopsis/SymbolLookup/Walker.html#current_scope_l_r" title="member function Synopsis::SymbolLookup::Walker::current_scope()">current_scope</a>() { <span class="keyword">return</span> <a href="../../../Scopes/Synopsis/SymbolLookup/Walker.html#my_scopes" title="data member Synopsis::SymbolLookup::Walker::my_scopes">my_scopes</a>.<a href="" title="member function std::stack::top()">top</a>();}</span>
<a id="line49"></a><span class="lineno">49</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/Walker.html#leave_scope_l_r" title="member function Synopsis::SymbolLookup::Walker::leave_scope()">leave_scope</a>();</span>
<a id="line50"></a><span class="lineno">50</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line51"></a><span class="lineno">51</span><span class="line">  <span class="keyword">typedef</span> std::<a href="" title="class std::stack">stack</a>&lt;<a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope</a> *&gt; <a href="../../../Scopes/Synopsis/SymbolLookup/Walker.html#Scopes" title="typedef Synopsis::SymbolLookup::Walker::Scopes">Scopes</a>;</span>
<a id="line52"></a><span class="lineno">52</span>
<a id="line53"></a><span class="lineno">53</span><span class="line">  <span class="comment">//. the virtual visit(Block) version above does scoping,</span></span>
<a id="line54"></a><span class="lineno">54</span><span class="line"><span class="comment">  //. which isn't what we want if traversing a function (FIXME: or is it ?)</span></span>
<a id="line55"></a><span class="lineno">55</span><span class="line"><span class="comment">  //. so the following factors out the common code.</span></span>
<a id="line56"></a><span class="lineno">56</span><span class="line">  <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolLookup::Walker::visit_block(PTree::Block*)">visit_block</a>(<a href="../../../Scopes/Synopsis/PTree/Block.html" title="class Synopsis::PTree::Block">PTree::Block</a> *);</span>
<a id="line57"></a><span class="lineno">57</span><span class="line">  <span class="comment">//. The symbol lookup table.</span></span>
<a id="line58"></a><span class="lineno">58</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/Walker.html#Scopes" title="typedef Synopsis::SymbolLookup::Walker::Scopes">Scopes</a>  <a href="../../../Scopes/Synopsis/SymbolLookup/Walker.html#my_scopes" title="data member Synopsis::SymbolLookup::Walker::my_scopes">my_scopes</a>;</span>
<a id="line59"></a><span class="lineno">59</span><span class="line">};</span>
<a id="line60"></a><span class="lineno">60</span>
<a id="line61"></a><span class="lineno">61</span><span class="line">}</span>
<a id="line62"></a><span class="lineno">62</span><span class="line">}</span>
<a id="line63"></a><span class="lineno">63</span>
<a id="line64"></a><span class="lineno">64</span><span class="line">#endif</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:28:02 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
